#ifndef QRK_SCIP_UTILS_H
#define QRK_SCIP_UTILS_H

/*!
  \example ScipUtils.h

  \brief SCIP 2.0 ̎M

  \author Satofumi KAMIMURA

  $Id: ScipUtils.h 783 2009-05-05 08:56:26Z satofumi $
*/

#include <vector>
#include <string>


namespace qrk {
  class Connection;

  enum {
    ScipTimeout = 200,          //!< [msec]
  };
}


/*!
  \brief SCIP f[^̃fR[h

  \param[in] code fR[h
  \param[in] byte fR[h

  \retval fR[h
*/
extern int decode(const char code[], int byte);


/*!
  \brief ȈՃR}hM

  \param[in] con ڑIuWFNg
  \param timeout M^CAEg [msec]
  \param[out] lines Mf[^̊i[p

  \retval 0 I
  retval < 0 G[
*/
extern int recvReply(qrk::Connection* con, int timeout,
                     std::vector<std::string>* lines = NULL);

#endif /* !QRK_SCIP_UTILS_H */
